#include "smtp.h"
extern smtpi jtin;



// S:2005-08-29 gorila@dione.zcu.cz
int smtp_out_packets_iq(smtpp par, char *type)
   {
   int liProcess=0;
   jpacket jp=par->jp;
   smtp_jq loQueue=NULL;
   smtp_jq_x loData;
   char *lcID=xmlnode_get_attrib(jp->x, "id"),*lcFile,*lcJID;
   xmlnode loFile,loJID,loMC,loQuery;
   pool p=par->tmppool;


   if (liProcess==0 && 
       j_strcmp(lcID,"smtp_test_jep0033")==0 &&
       j_strcmp(jp->iqns,"http://jabber.org/protocol/disco#info")==0)
      {

      #ifdef SMTP_DB
       SMTP_DEBUG(SMTP_ZONE,"I get reply to answer on JEP-0033");
      #endif

      if (xmlnode_get_tag(jp->x,"query/feature?var=http://jabber.org/protocol/address"))
         jtin->jep0033=1;

      return -1;
      }



   if (liProcess==0 && lcID &&
       strncmp("viprpc-",lcID,7)==0 &&
       jp->subtype==JPACKET__RESULT &&
       j_strcmp(jp->iqns,NS_IQ_RPC)==0)
      {
      // najdi ho v rosteru
      lcJID=lcID;
      lcJID+=7; // move pointer to jid id='viprpc-xx@jabbim.cz'>
      loJID=xmlnode_get_tag(jtin->roster_files,spools(p,"file/item?jid=",lcJID,p));
     
      if (loJID!=NULL)
         {
         #ifdef SMTP_DB
          SMTP_DEBUG(SMTP_ZONE,"I get reply to answer on XEP-0009 %s %s %s",lcJID,xmlnode_get_data(xmlnode_get_tag(jp->x,"query/methodResponse/params/param/value/int")),xmlnode_get_attrib(loJID,"J2S_SRText"));
         #endif
         xmlnode_put_attrib(loJID,"paid",xmlnode_get_data(xmlnode_get_tag(jp->x,"query/methodResponse/params/param/value/int")));

         loFile=loJID->parent;
         lcFile=xmlnode_get_tag_data(jtin->roster,spools(p,"file?type=",xmlnode_get_attrib(loFile,"type"),p))  ;

         if (lcFile!=NULL && xmlnode2file(lcFile,xmlnode_dup_pool(p,loFile))!=1)
            {
            log_alert("smtp","ROSTER - Cannot save roster-letter file %s.",lcFile);
            smtp_SendInfoToAdmin(spools(p,"ROSTER - Cannot save roster-letter file ",lcFile,".",p ),SMTP_SITA_P);
            }
         }
      else
         {
         log_warn("smtp","VIP RPC FAILED: ID: %s, JID: %s", lcID,lcJID);
         smtp_SendInfoToAdmin(spools(p,"VIP RPC FAILED: ID: ",lcID," JID:",lcJID,p),SMTP_SITA_M);
         }
      return -1;
      }


   if (liProcess==0 && lcID &&
       strncmp("viprpc-",lcID,7)==0 &&
       jp->subtype==JPACKET__SET &&
       j_strcmp(jp->iqns,NS_IQ_RPC)==0)
      {
      #ifdef SMTP_DB
       SMTP_DEBUG(SMTP_ZONE,"I get SET for XEP-0009");
      #endif

      loQueue=smtp_NewQueueItem(p,SMTP_QUEUE_X);
      loData=(smtp_jq_x) loQueue->Data;
      loData->x=out_SetReply(xmlnode_new_tag("iq"),jp->x);
      smtp_PoolsReg(8888, xmlnode_pool(loData->x));

      xmlnode_put_attrib(loData->x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(loData->x,"query"),"xmlns",jp->iqns);

      loMC=xmlnode_insert_tag(loQuery,"methodResponse");
      loMC=xmlnode_insert_tag(loMC,"params");
      loMC=xmlnode_insert_tag(loMC,"param");
      loMC=xmlnode_insert_tag(loMC,"value");
      xmlnode_insert_cdata(xmlnode_insert_tag(loMC,"int"),"1",-1);

      liProcess=1;
      }


   if (liProcess==1)
      smtp_FlushQueue(par->i, loQueue);


   if (liProcess==0)
      liProcess=smtp_out_packets_iq_register(par,type);

   if (liProcess==0)
      liProcess=smtp_out_packets_iq_vcard(par,type);

   if (liProcess==0)
      liProcess=smtp_out_packets_iq_gateway(par,type);

   if (liProcess==0)
      liProcess=smtp_out_packets_iq_time(par,type);

   if (liProcess==0)
      liProcess=smtp_out_packets_iq_version(par,type);

   if (liProcess==0)
      liProcess=smtp_out_packets_iq_stats(par,type);

   if (liProcess==0)
      liProcess=smtp_out_packets_iq_di(par,type);


   return liProcess;
   }

// E:2005-08-29 gorila@dione.zcu.cz
